#ifndef __TYPES_H
#define __TYPES_H

// Maybe we should give up using types like `uint`, 
// but use types with a clear size, say `uint32`
typedef unsigned int   uint;
typedef unsigned short ushort;
typedef unsigned char  uchar;
typedef unsigned short wchar;

typedef unsigned char uint8;
typedef unsigned short uint16;
typedef unsigned int  uint32;
typedef unsigned long uint64;

typedef char int8;
typedef short int16;
typedef int int32;
typedef long int64;

typedef unsigned long uintptr_t;
typedef uint64 pde_t;

// #define NULL ((void *)0)
#define NULL 0

#define readb(addr) (*(volatile uint8 *)(addr))
#define readw(addr) (*(volatile uint16 *)(addr))
#define readd(addr) (*(volatile uint32 *)(addr))
#define readq(addr) (*(volatile uint64 *)(addr))

#define writeb(v, addr)	{ (*(volatile uint8 *)(addr)) = (v); }
#define writew(v, addr)	{ (*(volatile uint16 *)(addr)) = (v); }
#define writed(v, addr)	{ (*(volatile uint32 *)(addr)) = (v); }
#define writeq(v, addr)	{ (*(volatile uint64 *)(addr)) = (v); }

#define NELEM(x) (sizeof(x)/sizeof((x)[0]))

#define offsetof(TYPE, MEMBER) ((uint64) &((TYPE *)0)->MEMBER)

#define container_of(ptr, type, member) ({			\
		const typeof( ((type *)0)->member ) *__mptr = (ptr);	\
		(type *)( (char *)__mptr - offsetof(type,member) );})


#endif
